unit MyTrd;

interface

uses
  Classes, Windows, SysUtils, TLMObject, MainFrm;

type
  TMyThread = class(TThread)
  private
    { Private declarations }
    FCount:Integer;
    FtlmObject:TtlmObject;
    procedure DoCount();
    procedure DoCountEnd();
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended:Boolean);
    destructor Destroy();override;
  end;

implementation

{ TMyThread }

procedure TMyThread.DoCount();
begin
  MainForm.ThreadCallBack(FtlmObject.Translate('ThreadCount','I''m a thread, This is [%d].',[FCount]));
end;

procedure TMyThread.DoCountEnd();
begin
  MainForm.ThreadCallback(FtlmObject.Translate('ThreadCountEnd','Thread count ended.'));
end;

procedure TMyThread.Execute;
begin
  FreeOnTerminate:=true;
  while not Terminated do begin
    Inc(FCount);
    if FCount>100 then
      break;
    Synchronize(DoCount);
    Sleep(300);
  end;
  Synchronize(DoCountEnd);
end;

constructor TMyThread.Create(CreateSuspended:Boolean);
begin
  inherited Create(CreateSuspended);
  FtlmObject:=TtlmObject.Create(self);
  FCount:=0;
end;

destructor TMyThread.Destroy();
begin
  FtlmObject.Free;
  inherited Destroy();
end;

end.
 